-- MoonTimeLayoutObj.lua

function MoonTimeLayoutObj()
	-- dieses Frame besitzt die Funktionen:
	-- GetStarrainCD
	-- GetTreantsCD
	-- GetStarsurgeCD
	-- GetMoonfireCD
	-- GetInsectSwarmCD
	-- GetEclipseEndTimes
	-- Next()
	local frame = CreateFrame( "Frame" )
	
	local expirationTime, start, duration, enabled, unitCaster, name, texture, active
	local hpdiff, timediff, timetilldeath, dir, power, EDir, EPower, spell, startTime, endTime, castID, change, charges, maxCharges, start, duration
	
	
	
	frame.GetStarfallDuration = function()
		_, _, _, _, _, _, expirationTime = UnitBuff("player", SR_name) 
		
		if expirationTime == nil then 
			return 0
		end
		
		return expirationTime-GetTime();
	end
	
	frame.GetTreantsCD = function()
		start, duration, enabled = GetSpellCooldown(Treants_id);
		
		return start+duration-GetTime();
	end

	frame.GetStarsurgeCD = function()
		start, duration, enabled = GetSpellCooldown(SS_id);
		return start+duration-GetTime();
	end
	
	frame.GetMoonfireCD = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitDebuff("target", MF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
		else
			return -1, GetTime();
		end
	end

	frame.GetSunfireCD = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitDebuff("target", SunF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
		else
			return -1, GetTime();
		end
	end

	frame.GetFaerieFireCD = function()
		_, _, _, _, _, _, expirationTime, unitCaster = UnitDebuff("target", FF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime();
		else
			return -1;
		end
		end
	
	frame.GetCelestialAlignmentCD = function()
		start, duration = GetSpellCooldown(CA_id);
		return start+duration-GetTime();
	end	

	frame.GetTalentCD = function( self, row, col )
		_, name, texture, active = GetTalentInfo( row, col, 1)
		
		if active then
			start, duration, enabled = GetSpellCooldown(name);	
				if duration < 2 then return 0, duration end
			return start+duration-GetTime(), duration;
		else
			return -1, 0
		end
	end

	frame.GetRejuvenationDuration = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitBuff("player", R_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
		else
			return -1;
		end			
	end	
	
	
	frame.GetEclipseDirection = function()
		dir = GetEclipseDirection()
		
		--DEFAULT_CHAT_FRAME:AddMessage(dir)
		
		if ( dir == "none" ) then
			dir = "moon";
		end
		local power = UnitPower("player", 8)
		
		return dir, power
	end



	frame.GetCelestialAlignmentDuration = function()
		name, _, _, _, _, _, expirationTime = UnitBuff("player", CA_name);

		if name then
			return expirationTime-GetTime();
		else
			return -1
		end
	end	
	


	frame.GetCharges = function ()
		charges, maxCharges, start, duration = GetSpellCharges(SS_id)
		
		if charges == maxCharges then
			return charges, -1
		else
			return charges, start+duration-GetTime()
		end
	end
		
		
	frame.IsLunarEmpowered = function ()
		name, _, _, count = UnitBuff("player", LE_name)
		
		if name then
			return count
		else
			return 0
		end
	end	
	
	frame.IsSolarEmpowered = function ()
		name, _, _, count = UnitBuff("player", SE_name)
		
		if name then
			return count
		else
			return 0
		end
	end	
	
	
	frame.IsLunarPeak = function ()
		name = UnitBuff("player", LP_name)
		
		if name then
			return true
		else
			return false
		end
	end	
	
	frame.IsSolarPeak = function ()
		name = UnitBuff("player", SP_name)
		
		if name then
			return true
		else
			return false
		end
	end	
	
	
	
	frame.IsEmpowered = function ()		
		if frame.IsLunarEmpowered() or frame.IsSolarEmpowered() then
			return true
		else
			return false
		end
	end

	frame.GetFuturePower = function(t)
		local EDir, EPower = frame.GetEclipseDirection()

		if EDir == "moon" then
			return min(max(-round(sin(-(asin(EPower/110)/90*10-t)/10*90)*110),-100),100)
		else
			return min(max(-round(sin(-(asin(EPower/110)/90*10+t)/10*90)*110),-100),100)
		end
	end
	
	-- 58.66 rating @100 ?
	frame.GetLunarAmp = function(t)
		return 1 + (100-frame.GetFuturePower(t))/200 * (GetCombatRating(CR_MASTERY)/12.26+15)/100
	end

	frame.GetSolarAmp = function(t)
		return 1 + (100+frame.GetFuturePower(t))/200 * (GetCombatRating(CR_MASTERY)/12.26+15)/100
	end


	
	frame.isSolar = function(t)
		if not t then t=0 end
		
		if frame.GetFuturePower(t) > 0 then
			return true
		else
			return false
		end
	end
 
	frame.isLunar = function(t)
		return not frame.isSolar(t)
	end
	
	

	return frame
end
		
	