-- MejLayout.lua
local NameOfLayout = "Mej"
local Description;
local layerFrame


local function Layout(mainFrame, cds)
	-- Update()
	-- CreateCastFrame( spellTexture, RTframe, height, width, relwhich, relto )
	-- createLayout()
	-- deleteLayout()

	local MoonTimeNextCastframe
	local MoonTimeEclipseframe
	local MoonTimeMoonfireframe
	local MoonTimeInsectswarmframe
	local MoonTimeStarrainframe
	local MoonTimeStarsurgeframe
	
	RunScript(MoonTime_mynext_start .. MoonTime_DB["Layout_noBrain"][MoonTime_DB["Layout_noBrain"]["rotation"]] .. " end")
	
	
	
	
	local layerFrame = CreateFrame("Frame", "layerFrame", mainFrame )
	layerFrame:SetHeight( mainFrame:GetHeight() )
	layerFrame:SetWidth( mainFrame:GetWidth() )
	layerFrame:SetPoint("CENTER")
	layerFrame:Hide()
	
	layerFrame.Update = function()
		MoonTimeNextCastframe:SetIcon(mynext(cds))

		local EDir, Epower = cds:GetEclipseDirection()
		local MF = cds:GetMoonfireCD()
		local SunF = cds:GetSunfireCD()
		local SS_CD = cds:GetStarsurgeCD()
		local SR_cd = cds:GetStarfallCD()
		local Treants_cd = cds:GetTreantsCD()

		if( EDir == "sun" ) then 
			MoonTimeEclipseframe:SetIcon( Lunar_icon )
			local color = "ffff00"
			local bool = false
			if ( Epower < 0 ) then 
				color = "0088ff" 
				Epower = -1 * Epower
				bool = true
			end
			MoonTimeEclipseframe:SetText( "|cff"..color..Epower.."|r", bool);
		end

		if( EDir == "moon" ) then 
			MoonTimeEclipseframe:SetIcon( Solar_icon )		
			local color = "ffff00"
			local bool = true
			if ( Epower < 0 ) then 
				color = "0088ff" 
				Epower = -1 * Epower
				bool = false
			end
			MoonTimeEclipseframe:SetText( "|cff"..color..Epower.."|r", bool);
		end
		
		if MF>=0 then
			MoonTimeMoonfireframe:SetText( string.format("%2.1f", (MF) ) , false)
		else
			MoonTimeMoonfireframe:SetText( '', true )
		end
		
		if SunF>=0 then
			MoonTimeSunfireframe:SetText( string.format("%2.1f", (SunF) ), false )
		else
			MoonTimeSunfireframe:SetText( '', true )
		end


	end

	layerFrame.CreateCastFrame = function( spellTexture, RTframe, height, width, relwhich, relto )
		local frame = CreateFrame( "Frame", "MTCastframe"..RTframe:GetName(), layerFrame )
		frame:SetBackdrop({
			bgFile = "Interface\\TUTORIALFRAME\\TutorialFrameBackground",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = height, edgeSize = 10,
			insets = { left = 2, right = 2, top = 2, bottom = 2 }
		})
		frame:SetHeight(height)
		frame:SetWidth(width)
		frame:SetPoint(relwhich, RTframe, relto, 0, 0)

		local iconframe = CreateFrame( "Frame", "MTCastframe"..RTframe:GetName(), frame )
		iconframe:SetPoint("LEFT", frame, "LEFT")

		iconframe:SetHeight(height)
		iconframe:SetWidth(height)
		iconframe.texture = iconframe:CreateTexture("MejLayoutTexture")
			iconframe.texture:SetTexture(spellTexture)
			iconframe.texture:SetAllPoints()
		
		local labelframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		labelframe:SetPoint("TOPLEFT", iconframe, "TOPRIGHT")
		labelframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
		labelframe:SetTextColor( 1, 1, 0, 1 );
		frame.SetAlpha = function( self, bool )
			if bool then
				iconframe.texture:SetVertexColor(1,1,1,1)		
			else
				iconframe.texture:SetVertexColor(1,1,1,.5)		
			end
		end
		frame.SetText = function( self, msg, bool )
			self:SetAlpha(bool)
			labelframe:SetText(msg)
		end
		frame.SetIcon = function( self, icon )
			iconframe.texture:SetTexture(icon)
		end
		
		return frame
	end

	layerFrame.createLayout = function ()
		mainFrame:SetHeight(96)
		mainFrame:SetWidth(64)
		local castwidth = 72
		local castheight = 24
		-- Layout fuer eliteFrame
		
		MoonTimeNextCastframe = layerFrame.CreateCastFrame( "", layerFrame, 48, 48, "TOP", "CENTER")
		MoonTimeEclipseframe = layerFrame.CreateCastFrame( "Interface\\Icons\\Ability_Druid_Eclipse", MoonTimeNextCastframe, castheight, castwidth, "TOP", "BOTTOM")
		MoonTimeMoonfireframe = layerFrame.CreateCastFrame( MF_icon, MoonTimeEclipseframe, castheight, castwidth, "TOP", "BOTTOM")
		MoonTimeSunfireframe = layerFrame.CreateCastFrame( SunF_icon, MoonTimeMoonfireframe, castheight, castwidth, "TOP", "BOTTOM")
	end
	

	layerFrame.deleteLayout = function()
		MoonTimeNextCastframe:Hide()
		MoonTimeNextCastframe = nil
		MoonTimeEclipseframe:Hide()
		MoonTimeEclipseframe = nil
		MoonTimeMoonfireframe:Hide()
		MoonTimeMoonfireframe = nil
		MoonTimeSunfireframe:Hide()
		MoonTimeSunfireframe = nil
		
		layerFrame:Hide()
		layerFrame = nil
	end

	return layerFrame
end

-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerLayout( name )									-- Beginn initialize
	local LayoutFrame
	local frame = CreateFrame( "Frame", name, UIPARENT	)
	frame.ID = name
	frame:RegisterEvent("VARIABLES_LOADED");
	frame:SetScript("OnEvent", 
		function( self, event )
			if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
																		-- werden die ausstehenden Events registriert
				if ( GetLocale() == "deDE" ) then
					frame.description = MoonTime_Mej_Strings["deDE"]["description"]
				else
					frame.description = MoonTime_Mej_Strings["enGB"]["description"]
				end
				
				MoonTimeDoorKeeper:RegisterLayout(self);
			end
		end
	)
	
	frame.createLayout = function( self ) 
		LayoutFrame = Layout(self.Mainframe, self.Objectframe)
		LayoutFrame:createLayout()
	end

	frame.Hide = function()
		LayoutFrame:Hide()
	end
	frame.Show = function()
		LayoutFrame:Show()
	end
	frame.Update = function()
		LayoutFrame:Update()
	end

	frame.deleteLayout = function()
		LayoutFrame:deleteLayout()
	end
end																		-- Ende initialize

registerLayout(NameOfLayout)
